/* stmt.c
	P. Chongstitvatana
			25 Aug 97
   add after 		22 Aug 98

	3 Apr 2001  start project RZ
	automatic generate	26 Apr 2001
	add patchif()  21 Dec 2001
*/

#include "compile.h"

#define		PRIVATE		static

extern int pass;
extern int lv;		/* symtab.c */

void pass2() {
  pass = 2;
  out2(icCall,mainRef);
  out(icStop);
  lex();
  ps2(); /* parse.c */
}

int setFunc(char *num) {	/* set ref and gen icFunc,pv,0 */
  int a,type,ref,pv;
  a = atoi(num);
  getAt(a,&type,&ref,&pv);
  setRef(a,CP);
  out3(icFunc,pv,0);
  return pv;
}

/* insert formal paramters into local symbol, check duplicate */
void insertLocal(char *name){
	int a, found;
	a = installLocal(name, &found);
	if(found) seterror("duplicate formal parameter");
}

/* find ref of tokstring, ret index to symtab[] */
int getsym(char *name, int *type, int *ref, int *arg){
	int a;
	a = install(name);
	getAt(a,type,ref,arg);
// printf("index %d name %s type %d ref %d arg %d\n",a,name,*type,*ref,*arg);
	return a;
}

void clean() {
  int c;
  c = CS[CP - 1];
  if( c != icRet0 && c != icRet1 )
    out(icRet0);
  lv = 0;	// clear local symbol
}

void printstr() {
  char *s;
  s = tokstring;
  while( *s != '\0' ) {
    if( *s == '\\' && *(s+1) == 'n' ) {
      out2(icLit,13); out(icPrintch);
      out2(icLit,10); out(icPrintch);
      s += 2;
    } else {
      out2(icLit,*s); out(icPrintch);
      s++;
    }
  }
}

void chktype(int type1, int type2) {
  if( type1 != type2 ) seterror("identifier type mismatch");
}

/* parse argument list, check number of args */
void doparam(int count) {
  int pv = 0;
  while( tok != tkRPAREN && tok != tkEOF ) {
    expr();
    pv++;
    if( tok == tkCOMMA) lex();
  }
  if(pv != count) seterror("incorrect number of arguments");
}

void doLval(int type, int ref) {
  switch( type ) {
  case tySCALAR : out2(icLvalg,ref); break;
  case tyLOCAL : out2(icLval,ref); break;
  default : seterror("identifier type mismatch");
  }
}

void doRval(int type, int ref) {
  switch( type ) {
  case tySCALAR : out2(icRvalg,ref); break;
  case tyLOCAL : out2(icRval,ref); break;
  default : seterror("identifier type mismatch");
  }
}

void commit( int status ) {
  if ( status == 0 ) seterror("syntax");
}

/* fix ifelse stmt 21 Dec 2001 */
void patchif( int a, int b, int here ){
	if( b == here )
		patch(a,here);   /* no else stmt */
	else {
		patch(a,b+3);    /* jump to else stmt */
		patch(b+1,here); /* jump out */
	}
}
